define("scarabTensionApi", ["componentmodelComponentApi", "clientkernelEventbusApi"],
    function(componentmodelComponentApi, clientkernelEventbusApi) {
        "use strict";

        function $iterator(o) {
            if (o instanceof Array) return function() {
                return {
                    cur: 0,
                    arr: o,
                    hasNext: function() {
                        return this.cur < this.arr.length;
                    },
                    next: function() {
                        return this.arr[this.cur++];
                    }
                };
            };
            return typeof(o.iterator) == 'function' ? $bind(o, o.iterator) : o.iterator;
        };;
        var $fid = 0;

        function $bind(o, m) {
            if (m == null) return null;
            if (m.__id__ == null) m.__id__ = $fid++;
            var f;
            if (o.hx__closures__ == null) o.hx__closures__ = {};
            else f = o.hx__closures__[m.__id__];
            if (f == null) {
                f = function() {
                    return f.method.apply(f.scope, arguments);
                };
                f.scope = o;
                f.method = m;
                o.hx__closures__[m.__id__] = f;
            }
            return f;
        };
        var $_;
        var $estr = function() {
            return _hcmn_.js_Boot.__string_rec(this, '');
        };
        if (typeof scarabTensionApi == 'undefined') {
            var scarabTensionApi = {};
        };

        scarabTensionApi.ITensionImplementationPort = function() {}
        scarabTensionApi.ITensionImplementationPort.prototype = {

            getShowTension: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getHideTension: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getShowWildTension: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getHideWildTension: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };

        scarabTensionApi.ITensionPort = function() {}
        scarabTensionApi.ITensionPort.prototype = {

            getShowTension: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getHideTension: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getShowWildTension: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getHideWildTension: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };
        scarabTensionApi.TensionDeclaration = function() {};
        scarabTensionApi.TensionDeclaration = ck_implements(scarabTensionApi.TensionDeclaration, componentmodelComponentApi.IComponentDeclaration);
        scarabTensionApi.TensionDeclaration.__interfaces__ = [componentmodelComponentApi.IComponentDeclaration];
        scarabTensionApi.TensionDeclaration.__name__ = ["scarabTensionApi", "TensionDeclaration"];
        scarabTensionApi.TensionDeclaration.prototype.getChildComponents = function() {
            return null;
        };
        scarabTensionApi.TensionDeclaration.prototype.getReferredComponents = function() {
            return null;
        };
        scarabTensionApi.TensionDeclaration.prototype.getImplementedPorts = function() {
            return [scarabTensionApi.ITensionImplementationPort];
        };
        scarabTensionApi.TensionDeclaration.prototype.getUsedPorts = function() {
            return [scarabTensionApi.ITensionPort];
        };
        scarabTensionApi.TensionDeclaration.prototype.__class__ = scarabTensionApi.TensionDeclaration;
        scarabTensionApi.TensionPort = function(bus) {
            this.hideWildTension = new clientkernelEventbusApi.Topic("wildtension:hide");
            this.showWildTension = new clientkernelEventbusApi.Topic("wildtension:show");
            this.hideTension = new clientkernelEventbusApi.Topic("tension:hide");
            this.showTension = new clientkernelEventbusApi.Topic("tension:show");
            this.showTension.connect(bus);
            this.hideTension.connect(bus);
            this.showWildTension.connect(bus);
            this.hideWildTension.connect(bus);
        };
        scarabTensionApi.TensionPort = ck_implements(scarabTensionApi.TensionPort, scarabTensionApi.ITensionPort);
        scarabTensionApi.TensionPort = ck_implements(scarabTensionApi.TensionPort, scarabTensionApi.ITensionImplementationPort);
        scarabTensionApi.TensionPort.__interfaces__ = [scarabTensionApi.ITensionPort, scarabTensionApi.ITensionImplementationPort];
        scarabTensionApi.TensionPort.__name__ = ["scarabTensionApi", "TensionPort"];
        scarabTensionApi.TensionPort.prototype.showTension = null;
        scarabTensionApi.TensionPort.prototype.hideTension = null;
        scarabTensionApi.TensionPort.prototype.showWildTension = null;
        scarabTensionApi.TensionPort.prototype.hideWildTension = null;
        scarabTensionApi.TensionPort.prototype.getShowTension = function() {
            return this.showTension;
        };
        scarabTensionApi.TensionPort.prototype.getHideTension = function() {
            return this.hideTension;
        };
        scarabTensionApi.TensionPort.prototype.getShowWildTension = function() {
            return this.showWildTension;
        };
        scarabTensionApi.TensionPort.prototype.getHideWildTension = function() {
            return this.hideWildTension;
        };
        scarabTensionApi.TensionPort.prototype.__class__ = scarabTensionApi.TensionPort;
        scarabTensionApi.TensionPortFactory = function() {};
        scarabTensionApi.TensionPortFactory = ck_implements(scarabTensionApi.TensionPortFactory, componentmodelComponentApi.IPortFactory);
        scarabTensionApi.TensionPortFactory.__interfaces__ = [componentmodelComponentApi.IPortFactory];
        scarabTensionApi.TensionPortFactory.__name__ = ["scarabTensionApi", "TensionPortFactory"];
        scarabTensionApi.TensionPortFactory.prototype.provide = function(channel) {
            return new scarabTensionApi.TensionPort(channel);
        };
        scarabTensionApi.TensionPortFactory.prototype["use"] = function(channel) {
            return new scarabTensionApi.TensionPort(channel);
        };
        scarabTensionApi.TensionPortFactory.prototype.__class__ = scarabTensionApi.TensionPortFactory;
        scarabTensionApi.ShowTensionPayload = function(reels, reelId) {
            this.reels = reels;
            this.reelId = reelId;
        };
        scarabTensionApi.ShowTensionPayload.__name__ = ["scarabTensionApi", "ShowTensionPayload"];
        scarabTensionApi.ShowTensionPayload.prototype.reels = null;
        scarabTensionApi.ShowTensionPayload.prototype.reelId = null;
        scarabTensionApi.ShowTensionPayload.prototype.__class__ = scarabTensionApi.ShowTensionPayload;
        scarabTensionApi.TensionTypeEnum = {
            __ename__: ["scarabTensionApi", "TensionTypeEnum"],
            __constructs__: ["wild_tension", "tension_frame"]
        };
        scarabTensionApi.TensionTypeEnum.tension_frame = ["tension_frame", 1];
        scarabTensionApi.TensionTypeEnum.tension_frame.toString = $estr;
        scarabTensionApi.TensionTypeEnum.tension_frame.__enum__ = scarabTensionApi.TensionTypeEnum;
        scarabTensionApi.TensionTypeEnum.wild_tension = ["wild_tension", 0];
        scarabTensionApi.TensionTypeEnum.wild_tension.toString = $estr;
        scarabTensionApi.TensionTypeEnum.wild_tension.__enum__ = scarabTensionApi.TensionTypeEnum;
        if (typeof haxe == 'undefined') {
            var haxe = {};
        };

        haxe.IMap = function() {}
        haxe.IMap.prototype = {

        };
        return {
            exports: scarabTensionApi
        };
    });
//# sourceURL=scarabTensionApi.js